////////////////////////////////////////////////////////////////////////////////
// project: MIDlet Pascal 3.0
// author: Javier Santo Domingo (j-a-s-d@users.sourceforge.net)
// date: Feb 6th, 2010
// demo: RGBToCMYKDemo
////////////////////////////////////////////////////////////////////////////////

unit RGBToCMYK;

interface

type
  TRGBColor = record
    Red: integer;
    Green: integer;
    Blue: integer;
  end;

  TCMYKColor = record
    Cyan: real;
    Magenta: real;
    Yellow: real;
    KeyPlate: real;
  end;

function RGB2CMYK(rgbColor: TRGBColor): TCMYKColor;

implementation

function RGB2CMYK(rgbColor: TRGBColor): TCMYKColor;
var c,m,y,k: integer;
begin
  C := 255 - rgbColor.Red;
  M := 255 - rgbColor.Green;
  Y := 255 - rgbColor.Blue;
  if C < M then
    K := C
  else
    K := M;
  if Y < K then
    K := Y;
  if k > 0 then begin
    c := c - k;
    m := m - k;
    y := y - k;
  end;
  RGB2CMYK.Cyan := c;
  RGB2CMYK.Magenta := m;
  RGB2CMYK.Yellow := y;
  RGB2CMYK.KeyPlate := k;
end;

end.
